Attribute VB_Name = "mod1"
Option Explicit
 Const WM_INITDIALOG = &H110
'Private Const WM_USER = &H400
 Const WM_DESTROY = &H2
 Const WM_NOTIFY = &H4E
 Const CDN_FIRST As Long = (-601)
 Const CDN_FILEOK As Long = (CDN_FIRST - &H5)
 Const CDN_FOLDERCHANGE As Long = (CDN_FIRST - &H2)
 Const CDN_HELP As Long = (CDN_FIRST - &H4)
 Const CDN_INCLUDEITEM As Long = (CDN_FIRST - &H7)
 Const CDN_INITDONE As Long = (CDN_FIRST - &H0)
 Const CDN_SELCHANGE As Long = (CDN_FIRST - &H1)
 Const CDN_SHAREVIOLATION As Long = (CDN_FIRST - &H3)
 Const CDN_TYPECHANGE As Long = (CDN_FIRST - &H6)
 
 Const WM_USER = &H400
 Const CDM_FIRST = (WM_USER + 100)
 Const CDM_GETFILEPATH = (CDM_FIRST + &H1)
 Const CDM_GETSPEC As Long = (CDM_FIRST + &H0)

Public Enum Dlg_Flags
    OFN_ALLOWMULTISELECT = &H200&
    OFN_CREATEPROMPT = &H2000&
    OFN_DONTADDTORECENT = &H2000000
    OFN_ENABLEHOOK = &H20&
    OFN_ENABLEINCLUDENOTIFY = &H400000
    OFN_ENABLESIZING = &H800000
    OFN_ENABLETEMPLATE = &H40&
    OFN_ENABLETEMPLATEHANDLE = &H80&
    OFN_EX_NOPLACESBAR = &H1&
    OFN_EXPLORER = &H80000
    OFN_EXTENSIONDIFFERENT = &H400&
    OFN_FILEMUSTEXIST = &H1000&
    OFN_FORCESHOWHIDDEN = &H10000000
    OFN_HIDEREADONLY = &H4&
    OFN_LONGNAMES = &H200000
    OFN_NOCHANGEDIR = &H8&
    OFN_NODEREFERENCELINKS = &H100000
    OFN_NOLONGNAMES = &H40000
    OFN_NONETWORKBUTTON = &H20000
    OFN_NOREADONLYRETURN = &H8000&
    OFN_NOTESTFILECREATE = &H10000
    OFN_NOVALIDATE = &H100&
    OFN_OVERWRITEPROMPT = &H2&
    OFN_PATHMUSTEXIST = &H800&
    OFN_READONLY = &H1&
    OFN_SHAREAWARE = &H4000&
    OFN_SHAREFALLTHROUGH = 2
    OFN_SHARENOWARN = 1
    OFN_SHAREWARN = 0
    OFN_SHOWHELP = &H10&
    OFN_USEMONIKERS = &H1000000
End Enum
Private Type OPENFILENAME
    StructSize As Long
    Owner As Long
    Instance As Long
    Filter As String
'    CustomFilter As Long
    CustomFilter As String
    MaxCustrFilter As Long
    FilterIndex As Long
    File As String
    MaxFile As Long
    FileTitle As String
    MaxFileTitle As Long
    InitialDir As String
    Title As String
    Flags As Dlg_Flags
    FileOffset As Integer
    FileExtension As Integer
    DefExt As String
    CustrData As Long
    Hook As Long
    TemplateName As Long
  pvReserved        As Long  'new in Windows 2000 and later
  dwReserved        As Long  'new in Windows 2000 and later
  flagsEx           As Long  'new in Windows 2000 and later
End Type
Private Type OFN_TEMP
    StructSize As Long
    Owner As Long
    Instance As Long
    Filter As Long
'    CustomFilter As Long
    CustomFilter As Long
    MaxCustrFilter As Long
    FilterIndex As Long
    File As Long
    MaxFile As Long
    FileTitle As Long
    MaxFileTitle As Long
    InitialDir As Long
    Title As Long
    Flags As Long
    FileOffset As Integer
    FileExtension As Integer
    DefExt As Long
    CustrData As Long
    Hook As Long
    TemplateName As Long
  pvReserved        As Long  'new in Windows 2000 and later
  dwReserved        As Long  'new in Windows 2000 and later
  flagsEx           As Long  'new in Windows 2000 and later
End Type

Private Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type

Private Type OFNOTIFYshort
    hdr As NMHDR
    lpOFN As Long
End Type
Private Declare Function GetOpenFileNameA Lib "comdlg32.dll" _
   (OPENFILENAME As OPENFILENAME) As Boolean
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes As Long)
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Dim op As OPENFILENAME

Sub Main()
With op
      .Hook = GetAddress(AddressOf DialogHookFunction)
      .Instance = App.hInstance
      .StructSize = 88
      .Flags = OFN_ENABLEHOOK _
            Or OFN_EXPLORER _
            Or OFN_ENABLESIZING
      .File = String$(512 * 2, 0)
      .MaxFile = 512 * 2 - 1
      .CustomFilter = String(40, 0)
      .MaxCustrFilter = 40
      .Filter = ".bas" & vbNullChar & "*.bas" & vbNullChar _
               & "*.vbp" & vbNullChar & "*.vbp" & vbNullChar _
               & "*.*" & vbNullChar & "*.*" & vbNullChar & vbNullChar
      GetOpenFileNameA op
'              
      Debug.Print Split(.CustomFilter, vbNullChar)(1)
End With


End Sub

Public Function DialogHookFunction(ByVal hDlg As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
 
 Static DlgHwnd As Long

 On Error Resume Next
 
   Select Case wMsg
   Case WM_INITDIALOG
        DlgHwnd = GetParent(hDlg)
   Case WM_NOTIFY

           Dim tOFNs As OFNOTIFYshort

           CopyMemory tOFNs, ByVal lParam, Len(tOFNs)
           
           Select Case tOFNs.hdr.code
           Case CDN_TYPECHANGE
           Stop
'                 ?

'             :
                Dim opm As OFN_TEMP
                CopyMemory opm, ByVal tOFNs.lpOFN, Len(op)
                Debug.Print opm.CustomFilter
                Dim b() As Byte
                ReDim b(40)
                CopyMemory b(0), ByVal opm.CustomFilter, 40
                Dim s As String
                s = b
                Debug.Print s
                s = StrConv(s, vbUnicode)
                Debug.Print s
           
'           Case CDN_SELCHANGE
'           Case CDN_FILEOK
'           Case CDN_FOLDERCHANGE
'           Case CDN_HELP
           End Select
  Case WM_DESTROY
  Case Else
  End Select

End Function

Private Function GetAddress(lPtr As Long) As Long
  GetAddress = lPtr
End Function

